//+------------------------------------------------------------------+
//|                                                      EMA Cut.mq4 |
//|                                                            Jasus |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "roundrock"
#property link      ""


extern bool   UseSmallestLot       = false;
extern bool   Email       = false;


extern double MaxMarginToUse      =     0.2; // Maximum percent of margin to commit to each trade.
extern double Lots                =     0.1;
extern double ProfitPct           =     0.5;
extern double MaxMiniProfit       =  1000.0;
extern double MaxStdProfit        = 10000.0;
extern int    MiniSize         =   10000;
extern int    StdSize          =  100000;
extern int    Slippage         =       3;

extern bool   UseTradingHours     =    false;
extern int    StartHour           =       7;
extern int    FinishHour          =      15;


extern int    MagicNumber         =  7788993211;

int ExtCountedBars=0;

int ticketlong, ticketshort;

string   ccy;
int      tf;
double   pnt;
int barsTotal = 0;
int barTime =0;
int prevbarTime =0;
double openHigh=0;
double openLow=0;

double phantomStartPrice=0;
bool NewBarFormed = false;
bool CloseAll;
bool SymbolMarksCleared = false;

int OrderSendResult;
int Leverage;
int NumBuys, NumSells;
int TotalTrades;
int AccountTypeVal;

bool AccountIsMini;


double MaxLots;
double MinLots;
double UseLots, TotalLots, BuyLots, SellLots;
double EquityExit;
double PercentMarginLevel;
double DollarProfitTarget;
double MaxMarginVar;
double Investment;
string AccountTypeString;
string LastFlatBal;           double valLastFlatBal;
string LastFlatEq;            double valLastFlatEq;
string LowestMarginLevel;     double valLowestMarginLevel;
string LargestFloatingLoss;   double valLargestFloatingLoss;
string MaxFloatingDrawdown;   double valMaxFloatingDrawdown;
datetime GMT;
int closeCount=0;
double Ticket_Array[];

string ticketNumberString="";
int orderCount=0;
int curHour =0;

int init()
  { 
  SetGlobalVariableNames();
  InitGlobalVars();
  phantomStartPrice = iClose(NULL,0,1);
  Print("phantomStartPrice "+phantomStartPrice);
//---- indicators
  
   
//---- indicator buffers mapping
   
  
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

  return(0);
} 

void ClearSymbolMarks()
{

  SymbolMarksCleared=true;
  return(0);
}

//+------------------------------------------------------------------+
//|                 Set the lot size for any trades.                 |
//+------------------------------------------------------------------+

void SetLotSize()
{
  Investment = MaxMarginToUse / 100.0;

  // The symbol the EA is attached to should be good enough for the purposes of LOTSIZE
  UseLots = valLastFlatEq * Investment * (Leverage / MarketInfo(Symbol(), MODE_LOTSIZE));
  

  UseLots = StrToDouble(DoubleToStr(UseLots,2));
  
 // Print("UseLots1 "+UseLots);

  if (UseSmallestLot || UseLots < MinLots) {
      UseLots = MinLots;
      //Print("UseLots2 "+UseLots);
  }
  if (UseLots > MaxLots) {
   UseLots = MaxLots;
   //Print("UseLots3 "+UseLots);
   }

  return(0);
}

void GetAccountInfo()
{
  // Get account leverage, account type.
  Leverage       = AccountLeverage();

  AccountTypeVal = MarketInfo(Symbol(), MODE_LOTSIZE);
  MaxLots        = MarketInfo(Symbol(), MODE_MAXLOT);
  MinLots        = MarketInfo(Symbol(), MODE_MINLOT);

  return(0);
}

//+------------------------------------------------------------------+
//|                     Add to winning trades.                       |
//+------------------------------------------------------------------+

void AddIfNeeded()
{
  

  if (NewBarFormed == true &&
     CloseAll == false && !SymbolMarksCleared)
  {  
    
    string theSymbol=Symbol();
      
        if (phantomStartPrice <= iClose(NULL,0,1) &&  AllSymbolTradesInProfit(theSymbol, OP_BUY))
        {
          
            Comment("Adding a " + theSymbol + " buy trade..."+UseLots);
            Print("Adding a " + theSymbol + " long.");
            OrderSendResult = OrderSend(theSymbol,OP_BUY,UseLots,MarketInfo(theSymbol, MODE_ASK),
                                      Slippage,0,0,"Adding to a long phantom winner",MagicNumber,Blue);
            if (OrderSendResult > 0) {
            orderCount++;
               SymbolMarksCleared = true;
              // int idx= ArraySize(Ticket_Array);
              // Ticket_Array[idx]=OrderSendResult;
              if(ticketNumberString==""){
                  ticketNumberString = OrderSendResult+" ";
               }else{
                  ticketNumberString = ticketNumberString+OrderSendResult+" ";
               }
            }
            Sleep(1000);
          }
          else  if (phantomStartPrice > iClose(NULL,0,1) &&  AllSymbolTradesInProfit(theSymbol, OP_SELL))
          {
            Comment("Adding a " + theSymbol+ " sell trade...");
            Print("Adding a " + theSymbol + " short.");
            OrderSendResult = OrderSend(theSymbol,OP_SELL,UseLots,MarketInfo(theSymbol, MODE_BID),
                                        Slippage,0,0,"Adding to a short phantom winner",MagicNumber,Red);
             if (OrderSendResult > 0) {
               orderCount++;
               SymbolMarksCleared = true;
              //  idx= ArraySize(Ticket_Array);
              // Ticket_Array[idx]=OrderSendResult;
               
               if(ticketNumberString==""){
                  ticketNumberString = OrderSendResult+" ";
               }else{
                  ticketNumberString = ticketNumberString+OrderSendResult+" ";
               }
            }
            Sleep(1000);
          }
        }   
  

  return(0);
}


//+------------------------------------------------------------------+
//|                 Close all of the open trades.                    |
//+------------------------------------------------------------------+

void CloseAllTradesIfNeeded()
{
  if (CloseAll)
  {
  closeCount=closeCount+1;
 
  if (AccountEquity() > valLastFlatEq)
   {
     valLastFlatEq = AccountEquity();
     GlobalVariableSet(LastFlatEq,  valLastFlatEq);
   }
  int orderCloseIdx=0;
  
  Print("@@@@@@@@@@@@@@@@   Pop # "+closeCount+ " ...... OrdersTotal to close "+OrdersTotal()+" orderCount "+orderCount+" ticketNumberString"+ticketNumberString);
  
  int startIdx=0;
  string ticketNumber="";
  
  for(int k=0;k<orderCount;k++){
  
   int ticketIdx = StringFind( ticketNumberString, " ", startIdx) ;
   
   if(ticketIdx <1){
     Print("ticketNumberString "+ticketNumberString+" startIdx "+startIdx);
   }
   
   if(ticketIdx>-1){
     ticketNumber = StringSubstr( ticketNumberString, startIdx, (ticketIdx-startIdx)) ;
     Print("---- ticketNumber "+ticketNumber);
     
     bool orderSelectResult = OrderSelect(StrToInteger(ticketNumber),SELECT_BY_TICKET,MODE_TRADES);      
       
      // bool orderSelectResult = OrderSelect(i,SELECT_BY_POS ,MODE_TRADES);
       
       
       if(!orderSelectResult){
         Print("OrderSelect returned the error of ",GetLastError());
       }
     // Print("---------------- MagicNumber "+OrderMagicNumber());

      if (OrderMagicNumber() == MagicNumber)
      {
     // Print("---------------- OrderType "+OrderType());
        if (OrderType() == OP_BUY)
        {
          Comment("In full closure mode.  Closing a ", OrderSymbol(), " buy trade...");
          Print("----------------- In full closure mode.  Closing a ", OrderSymbol(), " buy trade...");
          OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_BID),Slippage,White);
          orderCloseIdx++;
         Sleep(10000);
        }    
        else
        if (OrderType() == OP_SELL)
        {
          Comment("In full closure mode.  Closing a ", OrderSymbol(), " sell trade...");
          Print("------------------In full closure mode.  Closing a ", OrderSymbol(), " sell trade...");
          OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_ASK),Slippage,White);
          orderCloseIdx++;
          Sleep(10000);
        }   
        
        } 
     
      }  
   
   startIdx = ticketIdx+1;
  
  }
  
  
  /*int orderTotal = OrdersTotal();
  
  int orderSize = ArraySize(Ticket_Array);
  
    for(int i = 0; i < orderTotal; i++)
   //  for(int i = 0; i < orderSize; i++)
    
    {
    Print("---------------- int i "+i + " orderTotal "+orderTotal );
       bool orderSelectResult = OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
       
       
       
      // bool orderSelectResult = OrderSelect(i,SELECT_BY_POS ,MODE_TRADES);
       
       
       if(!orderSelectResult){
         Print("OrderSelect returned the error of ",GetLastError());
       }
      Print("---------------- MagicNumber "+OrderMagicNumber());

      if (OrderMagicNumber() == MagicNumber)
      {
      Print("---------------- OrderType "+OrderType());
        if (OrderType() == OP_BUY)
        {
          Comment("In full closure mode.  Closing a ", OrderSymbol(), " buy trade...");
          Print("----------------- In full closure mode.  Closing a ", OrderSymbol(), " buy trade...");
          OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_BID),Slippage,White);
          orderCloseIdx++;
         Sleep(10000);
        }    
        else
        if (OrderType() == OP_SELL)
        {
          Comment("In full closure mode.  Closing a ", OrderSymbol(), " sell trade...");
          Print("------------------In full closure mode.  Closing a ", OrderSymbol(), " sell trade...");
          OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_ASK),Slippage,White);
          orderCloseIdx++;
          Sleep(10000);
        }
      }
      
      }*/
             
      if(orderCloseIdx>0){   
         ticketNumberString="";
         Print("------------------ Closed  " +orderCloseIdx+ " trades ");
            
         //Alert("Closing Full ...... ",TimeToStr(TimeCurrent(),TIME_SECONDS),         " Time[0]=",TimeToStr(Time[0],TIME_SECONDS));
         // if (Email) SendMail("DIBS", "Popped out");
      
    }
    
    orderCount=0;
    
   // OpenWelcomeTrades(Symbol()); // open next cycle welcome trades
    phantomStartPrice = iClose(NULL,0,0);
  }
  
  
  return(0);
}

//+------------------------------------------------------------------+
//|                     Return true if new bar is created            |
//+------------------------------------------------------------------+
bool NewBar()
{
   
   
   
 // // Print("iTime "+iTime(NULL, 0, 0));
 //  int curbar = TimeMinute(iTime(NULL, 0, 0));
 // Print("curbar "+curbar +" period " +Period());
 
   if(Bars > barsTotal )

   {
      barsTotal = Bars;
      
      curHour = TimeHour(iTime(NULL, 0, 0));
   //Print("curbar "+curbar );
   
    //  Print("New bar has been formed. "+curHour);
    
    if(valLastFlatEq<AccountEquity()){
        double currentDD = valLastFlatEq -AccountEquity();
        double currentDDPct = (currentDD/AccountEquity())*100;
        Print("<<<<<<<<<<< Current DD "+ DoubleToStr(currentDD,2)+" DD Percentage "+DoubleToStr(currentDDPct,2));
    }
    
      
   //  Print("valLastFlatEq "+valLastFlatEq +" AccountEquity "+AccountEquity()+" DollarProfitTarget "+DollarProfitTarget);
      
      
      SymbolMarksCleared=false;
      return(true);
   }
  

   return(false);
   
   
}

void RefreshGlobalVars()
{
  valLowestMarginLevel = GlobalVariableGet(LowestMarginLevel);
  valLargestFloatingLoss = GlobalVariableGet(LargestFloatingLoss);
  valMaxFloatingDrawdown = GlobalVariableGet(MaxFloatingDrawdown);

  valLastFlatBal = GlobalVariableGet(LastFlatBal);
  valLastFlatEq  = GlobalVariableGet(LastFlatEq);

  
  return(0);
}

//+------------------------------------------------------------------+
//|               Check if all symbol trades in profit.              |
//+------------------------------------------------------------------+

bool AllSymbolTradesInProfit(string theSymbol, int orderTypeI)
{
  for (int j = 0; j < OrdersTotal(); j++)
  {
    OrderSelect(j,SELECT_BY_POS,MODE_TRADES);

    if (OrderMagicNumber() == MagicNumber &&
        OrderSymbol() == theSymbol        && OrderType()==orderTypeI &&
        OrderProfit() <= 0.0)
    {
      return(false);
    }
  }

  return(true);
}


void OpenWelcomeTrades(string symbolToTrade){

   Comment("Adding a welcome " + symbolToTrade + " buy trade...");
            Print("Adding a welcome " + symbolToTrade + " long.");
            OrderSendResult = OrderSend(symbolToTrade,OP_BUY,UseLots,MarketInfo(symbolToTrade, MODE_ASK),
                                      Slippage,0,0,"Welcome Trade Long",MagicNumber,Blue);
                                      
           if (OrderSendResult < 0)  {                        
               Print("Long OrderSend failed with error #",GetLastError()); 
           }else{
               if(ticketNumberString==""){
                  ticketNumberString = OrderSendResult+" ";
               }else{
                  ticketNumberString = ticketNumberString+OrderSendResult+" ";
               }
           }
                                      
     Sleep(1000);

   Comment("Adding a welcome " + symbolToTrade + " sell trade...");
            Print("Adding a welcome " + symbolToTrade + " short.");
            OrderSendResult = OrderSend(symbolToTrade,OP_SELL,UseLots,MarketInfo(symbolToTrade, MODE_BID),
                                        Slippage,0,0,"Welcome Trade Short",MagicNumber,Red);
                                        
             if (OrderSendResult < 0)     {                     
               Print("Short OrderSend failed with error #",GetLastError()); 
           }else{
               if(ticketNumberString==""){
                  ticketNumberString = OrderSendResult+" ";
               }else{
                  ticketNumberString = ticketNumberString+OrderSendResult+" ";
               }
           
           }

}


void SetAccountType()
{
  if (AccountTypeVal == MiniSize || StringLen(Symbol()) == 7)
  {
    AccountIsMini     = true;
    AccountTypeString = "MINI";
  }
  else if (AccountTypeVal == StdSize || StringLen(Symbol()) == 6)
  {
    AccountIsMini     = false;
    AccountTypeString = "STANDARD";
  }
  
  return(0);
}

void SetExitTargets()
{
  DollarProfitTarget = StrToDouble(DoubleToStr(valLastFlatEq*ProfitPct/100.0,2));
  
  //Print("DollarProfitTarget "+DollarProfitTarget+" ProfitPct "+ProfitPct+" valLastFlatEq "+valLastFlatEq);

  if (AccountIsMini)
  {
    if (DollarProfitTarget > MaxMiniProfit) DollarProfitTarget = MaxMiniProfit;
  }
  else
  {
    if (DollarProfitTarget > MaxStdProfit) DollarProfitTarget = MaxStdProfit;
  }

  return(0);
}
void SetGlobalVariableNames()
{
  LowestMarginLevel = MagicNumber+"_LowestMarginLevel";
  LargestFloatingLoss = MagicNumber+"_LargestFloatingLoss";
  MaxFloatingDrawdown = MagicNumber+"_MaxFloatingDrawdown";

  LastFlatBal = MagicNumber+"_LastFlatBal";
  LastFlatEq  = MagicNumber+"_LastFlatEq";  

  return(0);
}

void InitGlobalVars()
{
  if (!GlobalVariableCheck(LowestMarginLevel)) GlobalVariableSet(LowestMarginLevel, 100000000.0);
  if (!GlobalVariableCheck(LargestFloatingLoss)) GlobalVariableSet(LargestFloatingLoss, 0.0);
  if (!GlobalVariableCheck(MaxFloatingDrawdown)) GlobalVariableSet(MaxFloatingDrawdown, 0.0);

  if (!GlobalVariableCheck(LastFlatBal)) GlobalVariableSet(LastFlatBal, AccountBalance());
  if (!GlobalVariableCheck(LastFlatEq)) GlobalVariableSet(LastFlatEq, AccountEquity());

  valLastFlatEq = AccountEquity();
     GlobalVariableSet(LastFlatEq,  valLastFlatEq);
  
  return(0);
}


int start()
  {
  
    RefreshGlobalVars();
  GetAccountInfo();  
 
  SetAccountType();
  SetLotSize();  
  
  SetExitTargets();
  
     
     NewBarFormed = NewBar();     
     CloseAllTradesIfNeeded();
   //  Sleep(3000);
  // Print(" curHour "+curHour+"StartHour "+StartHour + " FinishHour "+FinishHour);
   if(UseTradingHours && StartHour < curHour && FinishHour > curHour) {
     AddIfNeeded();   
     
   }else if(!UseTradingHours){
      AddIfNeeded(); 
   }
     
     if (TotalTrades == 0)
  {
    if (AccountBalance() > valLastFlatBal)
    {
      valLastFlatBal = AccountBalance();
     // Print("valLastFlatBal "+valLastFlatBal+" AccountBalance() "+AccountBalance());
      GlobalVariableSet(LastFlatBal, valLastFlatBal);
    }

   // if (AccountEquity() > valLastFlatEq)
   // {
   //   valLastFlatEq = AccountEquity();
   //   GlobalVariableSet(LastFlatEq,  valLastFlatEq);
   // }
 

    CloseAll = false;
  }  
     
     if (!CloseAll && valLastFlatEq != 0.0 && AccountEquity()-valLastFlatEq > DollarProfitTarget)
      {
      //Print("-------- CloseAll  "+CloseAll );
         CloseAll = true;
         phantomStartPrice = iClose(NULL,0,1);

         return(0);
       }
     
         
    }
     
    
      
      
      
     
  
   


